<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2024 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2024-09-30
 */
define('IN_DOUCO', true);

$_CUR = 'language';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');

// 赋值给模板
$smarty->assign('rec', $rec);

if ($rec == 'insert') {
    // 验证并获取合法的值
    $language_pack = $check->is_language_pack($_POST['language_pack']) ? $_POST['language_pack'] : exit;
    $module = $check->is_basic_string($_POST['module']) ? $_POST['module'] : exit;
    $item_id = $check->is_number($_POST['item_id']) ? $_POST['item_id'] : exit;
    $field = $check->is_basic_string($_POST['field']) ? $_POST['field'] : exit;
    $type = $check->is_letter($_POST['type']) ? $_POST['type'] : exit;
    
    // 文件上传盒子
    if ($_POST['type'] == 'file') {
        $file = new File('images/' . $module . '/'); // 实例化类文件(文件上传路径，结尾加斜杠)
        $value = $file->box($module, $item_id, 'value', 'main');
    } else {
        $value = $_POST['value'];
    }
    
    // 数据格式化
    $add_time = time();
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $have_value = $dou->get_one("SELECT value FROM " . $dou->table('language_value') . " WHERE language_pack = '$language_pack' AND module = '$module' AND item_id = '$item_id' AND field = '$field' AND type = '$type' ORDER BY id DESC");
    
    if ($have_value) {
        $sql = "UPDATE " . $dou->table('language_value') . " SET value = '$value' WHERE language_pack = '$language_pack' AND module = '$module' AND item_id = '$item_id' AND field = '$field' AND type = '$type'";
        $dou->query($sql);
        
        $dou->create_admin_log($_LANG['language_edit'] . ': ' . $_POST['value']);
        
        $data['action'] = 'edit';
    } else {
        $sql = "INSERT INTO " . $dou->table('language_value') . " (id, language_pack, module, item_id, field, value, type, add_time)" . " VALUES (NULL, '$language_pack', '$module', '$item_id', '$field', '$value', '$type', '$add_time')";
        $dou->query($sql);
     
        $dou->create_admin_log($_LANG['language_add'] . ': ' . $_POST['value']);
     
        $data['action'] = 'add';
    }
    
    $data['id'] = $language_pack . '_' . $field;
    echo json_encode($data);
} 

/**
 * +----------------------------------------------------------
 * 对应的语言值
 * +----------------------------------------------------------
 */
elseif ($rec == 'value') {
    // 验证并获取合法的值
    $language_pack = $check->is_language_pack($_POST['language_pack']) ? $_POST['language_pack'] : exit;
    $module = $check->is_basic_string($_POST['module']) ? $_POST['module'] : exit;
    $item_id = $check->is_number($_POST['item_id']) ? $_POST['item_id'] : exit;
    $field = $check->is_basic_string($_POST['field']) ? $_POST['field'] : exit;
    $type = $check->is_letter($_POST['type']) ? $_POST['type'] : exit;
    
    $value = $dou->get_one("SELECT value FROM " . $dou->table('language_value') . " WHERE language_pack = '$language_pack' AND module = '$module' AND item_id = '$item_id' AND field = '$field' AND type = '$type' ORDER BY id DESC");
 
    if ($field == 'file' || $field == 'image' || $field == 'show_img') {
        $value = $dou->dou_file($value);
    }
    
    echo $value;
}

?>